// package com.turtlezero.string; 
import org.nlogo.api.* ;
import java.io.FileReader ;
import java.io.BufferedReader ;

public class JPS_FromFile extends DefaultReporter
{
    // take one string (filename) as input, report a string containing the file contents
	
    public Syntax getSyntax()
	{
        return Syntax.reporterSyntax(
            new int[] {Syntax.TYPE_STRING}, Syntax.TYPE_STRING
        ) ;
    }

    public Object report(Argument args[], Context context)
        throws ExtensionException, LogoException
    { String filename = args[0].getString() ;
      String result = null ;
      try
      {
          result = readFileAsString(filename) ;
      }
      catch (java.io.IOException e)
      { throw new ExtensionException(e) ;
      }
      return result ;
    }
    
    private static String readFileAsString(String filePath)
        throws java.io.IOException
    {
        StringBuffer fileData = new StringBuffer(1000);
        BufferedReader reader = new BufferedReader(
                new FileReader(filePath));
        char[] buf = new char[1024];
        int numRead=0;
        while((numRead=reader.read(buf)) != -1)
        {   fileData.append(buf, 0, numRead);
        }
        reader.close();
        return fileData.toString();
    }
}
