 extensions [ String ]

globals
[ xx yy zz aa bb cc test-results  
]

to startup
   ca
   ask patches [ set pcolor white ]
end

to test
   clear-output
   set test-results []
   
   let sample " Hello, World! "
   let upper-case-result " HELLO, WORLD! "
   let lower-case-result " hello, world! "
   let trim-result  "Hello, World!"
   let explode-result [ " " "H" "e" "l" "l" "o" "," " " "W" "o" "r" "l" "d" "!" " " ] 
   
   let sample2 "\"sample\",\"comma\",\"seperated\""
   let delim2 ","
   let split-result2 [ "\"sample\"" "\"comma\"" "\"seperated\"" ]
   
   let sample3 "strings0divided23by546numbers"
   let delim3 "[0-9]+"
   let split-result3 [ "strings" "divided" "by" "numbers" ]
   
   let sample4 "10.100.25.4"
   let delim4  "\\."
   let split-result4 [ "10" "100" "25" "4" ]
   
   let sample5 "this is nothing new27"
   let regex5 "[a-zA-Z ]+[0-9][0-9]"
   let match-result5 true
   
   let sample6 "replace first things first"
   let regex6 "first"
   let replacement6 "second"
   let replace-first6 "replace second things first"
   let replace-all6 "replace second things second"
   
   let sample7 "a test string"
   let starts-with7 "a test"
   let ends-with7 "string"
   let starts-with-result true
   let ends-with-result true
   let md5-result "b1a4cf30d3f495fa7d2a6676bcae77"
    
                       carefully [ output-print (word "sample = " q sample ) 
   ] [r error-message] carefully [ output-print (word "upper-case = " q string:upper-case sample )
   ] [r error-message] carefully [ output-print (word "lower-case = " q string:lower-case sample )
   ] [r error-message] carefully [ output-print (word "trim       = " q string:trim sample )
   ] [r error-message] carefully [ output-print (word "explode    = " string:explode sample )
   ] [r error-message] carefully [ output-print (word  q regex5  " rex-match " q sample5 " = " (string:rex-match regex5 sample5)  )
   ] [r error-message] carefully [ output-print (word "rex-replace-first " q regex6 " " q sample6 " " replacement6 " = " q (string:rex-replace-first    regex6 sample6 replacement6) )
   ] [r error-message] carefully [ output-print (word "rex-replace-all " q regex6 " " q sample6 " " replacement6 " = " q (string:rex-replace-all  regex6 sample6 replacement6) )
   ] [r error-message] carefully [ output-print (word "rex-split " q sample3 " " q delim3 " = " q (string:rex-split sample3 delim3) )
   ] [r error-message] carefully [ output-print (word "hash-code " q sample6 " = " string:hash-code sample6 )
   ] [r error-message] carefully [ output-print (word "hash-code " q sample3  " = " string:hash-code sample3  )
   ] [r error-message] carefully [ output-print (word "hash-code " q sample  " = " string:hash-code sample  )
   ] [r error-message] carefully [ output-print (word "message-digest " q sample6 " = " (string:message-digest-5  sample6 ) )
   ] [r error-message]


   ;; print (string:message-digest-5  [ "Hello World!" ]  )
   
      
   output-print "=============="
   output-print "  UNIT TESTS"
   output-print "=============="
   test-report "upper-case"            string:upper-case sample  upper-case-result
   test-report "lower-case"            string:lower-case sample  lower-case-result
   test-report "trim"                  string:trim sample trim-result
   test-report "explode"               string:explode sample explode-result
   test-report "rex-split(2)"          string:rex-split sample2 delim2  split-result2
   test-report "rex-split(3)"          string:rex-split sample3 delim3  split-result3
   test-report "rex-split(4)"          string:rex-split sample4 delim4  split-result4
   test-report "rex-match(5)"          string:rex-match regex5 sample5 match-result5 
   test-report "rex-replace-first(6)"  string:rex-replace-first regex6 sample6 replacement6 replace-first6
   test-report "rex-replace-all(6)"    string:rex-replace-all   regex6 sample6 replacement6 replace-all6
   test-report "starts-with(7)"        sample7 string:starts-with starts-with7 true
   test-report "ends-with(7)"          sample7 string:ends-with ends-with7 true
   test-report "hash-code(7)"          string:hash-code sample7 1121435168 
   test-report "message-digest-5(7)"   string:message-digest-5 sample7 md5-result
   
   test-summary
end

to test-report [ test-name test-result desired-result]
   ifelse test-result = desired-result
   [ set test-results fput (word  test-name " -- OK!") test-results ]
   [ set test-results fput (word  test-name " -- BAD (got: " test-result ", wanted: " desired-result ")" ) test-results ]
end

to test-summary
   foreach sort test-results
   [ output-print ? ]
   output-print "\n"
end   

to r [ err-msg ] output-print (word "Runtime-error: " err-msg) end

to-report q [ text ] report (word "\"" text "\"") end
   
@#$#@#$#@
GRAPHICS-WINDOW
532
10
627
126
8
8
5.0
1
9
1
1
1
0
1
1
1
-8
8
-8
8
0
0
0
ticks

CC-WINDOW
5
641
771
736
Command Center
0

BUTTON
11
31
66
64
NIL
test
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL

OUTPUT
12
68
762
627
12

TEXTBOX
10
10
321
28
JPS_Strings extension test, demonstration, and documentation
11
0.0
0

@#$#@#$#@
STRING
----------

WHAT IS IT?
----------

String is an extension for NetLogo written in Java using the NetLogo extensions API.

String provides an assortment of string processing reporters not provided in NetLogo.

This NetLogo file documents, tests, and demonstrates the function of the new primitives added through the String extension.

----------

HOW TO USE IT
----------

To use the String extension, put the folder String in either the extensions folder of your NetLogo installation, or in the same folder as the model file that will use the extension.

----------

THE STRING PRIMITIVES
----------

Descriptions of all the new primitives follow.

|
| UPPER-CASE

inputs: string
reports: string
syntax: string:upper-case <string>

reports the given string in upper case

|
| LOWER-CASE

inputs:  string
reports: string
syntax: string:lower-case <string>

reports the given string in lower case

| ############################################################
| TRIM

inputs: string
reports: string
syntax: string:trim <string>

reports the given string with leading and trailing spaces removed

| ############################################################
| ENDS-WITH

inputs: string, string-suffix
reports: boolean
syntax: <string> string:ends-with <suffix>

reports true if the given string ends with the given suffix.

| ############################################################
| STARTS-WITH

inputs: string, string-prefix
reports: boolean
syntax: <string> string:starts-with <prefix>

reports true if the given string starts with the given prefix.

| ############################################################
| EXPLODE

inputs: string
reports: list of single-chracter strings
syntax: string:explode <string>

reports the conversion of the string to a list of single characters

Example:
| code:    print explode "Hello!"
| output:  [ H e l l o ! ]

| ############################################################
| REX-SPLIT

input: string, regex-string
reports: a list of strings
syntax: string:rex-split <input> <pattern>

reports a list produced by splitting the given string using the given regular expression pattern into a list of strings. 

Example: Split on a single simple character (comma)
* Notice:  The repeated delimiter (,,) results in an empty string at that position
| code:    write string:rex-split "h,e,l,l,o,,there" ","
| output:  [ "h" "e" "l" "l" "o" "" "t" "h" "e" "r" "e" ]

Example: Split on a single character using a character class
| code: print string:rex-split "A1B2C3D4E" "[0-9]"
| output: [ A B C D E ]

Example: Split on an single character, escaped special character

* Notice:  The dot "." has to be escaped with "\\": Because dot "." has a special meaning in a regular expression, it must be escaped with "\", however, "\" has special meaning in NetLogo, so to actually get a "\", it must be escaped with another "\"

* Notice: rex-split always reports a list of strings, never numbers!

| code:    write string:rex-split "10.100.25.4" "\\."
| output:  [ "10" "100" "25" "4" ]

To convert a list of strings that look like numbers, you can use map and read-from-string:

let result split "10.100.25.4" "\."
let numbers map [ read-from-string ? ]  result

| ############################################################
| REX-MATCH

input: pattern, specimen
reports: boolean
syntax: string:rex-match <pattern> <specimen>

reports true if the given specimen is exactly matched by the given pattern (a regular expression)

Example: Match a string against a pattern that means "one or more letters or spaces, followed by exactly two digits"

| code:   print string:rex-match "[a-z A-Z]+[0-9][0-9]" "This is nothing new27" 
| output: true

| ############################################################
| REX-REPLACE-FIRST

input: pattern, specimen, replacement
reports: string
syntax: string:rex-replace-first <pattern> <specimen> <replacement>

reports the result of replacing the first match with the given pattern in the specimen with the replacement text.

| ############################################################
| REPLACE-ALL

input: pattern, specimen, replacement
reports: string
syntax: string:rex-replace-all <pattern> <specimen> <replacement>

reports the result of replacing every match with the given pattern in the specimen with the replacement text.

| ############################################################
| MESSAGE-DIGEST-5

input: string
reports: 30 character md5 result string
syntax string:message-digest-5 <string>

reports the MD5 hash of the input string

One great use of MD5 would be detecting repeating patterns in patches over time. Rather than storing (and comparing!) the entire set of patch data, one might need only store the MD5 of the patch data, then search that for repeats.

| ; example
| set tick-pattern string:md5
|        reduce
|         [ (word ?1 ?2) ]
|         map
|           [ [ pcolor ] of ? ]
|           sort patches
| 

Granted, that's not looking very fast. It would be helped by an extension reporter that quickly returned an unscrambled list of data from the patches, to avoid the extra overhead of list-ifying and sorting the patches.

| ############################################################
| HASH-CODE

input: string
reports: integer
syntax: string:hash-code <string>

reports the integer hash-code of the input string, 

| s[0]*31^(n-1) + s[1]*31^(n-2) + ... 

using integer math where s[i] is the i-th character of the string and n is the length of the string. The hash-code of the empty-string is 0.

| ############################################################
| FROM-FILE

input: filename
reports: string
syntax: string:from-file <filename>

reports a string containing the contents of the given file. currently doesn't work as expected with relative paths. works fine with absolute pathc.

----------

KNOWN BUGS
----------

| string:from-file 
string:from-file doesn't seem to work with relative paths I suspect it is not using the "current directory" when given a relative path. Works fine with absolute paths.


---------

COPYRIGHT
----------

Copyright  2007 James P. Steiner

This model file is free for all to use and modify and share but not to sell.
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

link
true
0
Line -7500403 true 150 0 150 300

link direction
true
0
Line -7500403 true 150 150 30 225
Line -7500403 true 150 150 270 225

@#$#@#$#@
NetLogo 4.0
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 0.0 1.0
0.0 1 1.0 0.0
0.2 0 0.0 1.0
link direction
true
0
Line -7500403 true 150 150 90 180
Line -7500403 true 150 150 210 180

@#$#@#$#@
